=== tests/requirements.txt ===
html-testRunner~=1.2.1
matplotlib~=3.8.0
numpy~=1.26.2
pandas~=2.1.3
pdoc3~=0.10.0
scipy~=1.11.4
