=== debian/changelog ===
libm2k (0.9.0-4) unstable; urgency=medium

  * Use -DCMAKE_POLICY_VERSION_MINIMUM=3.5 (Closes: #1113172)

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 13 Oct 2025 22:53:18 -0400

libm2k (0.9.0-3) unstable; urgency=medium

  [Michael Biebl]
  * Move aliased files from / to /usr (DEP17) (Closes: #1087698)

  [ A. Maitland Bottoms ]
  * correct build with --no-arch-any --arch-all (Closes: #1087664)

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 18 Nov 2024 20:29:51 -0500

libm2k (0.9.0-2) unstable; urgency=medium

  * Upload to unstable

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 16 Nov 2024 09:51:22 -0500

libm2k (0.9.0-1) experimental; urgency=medium

  * Package for Debian (Closes: #990057)

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 25 Oct 2024 23:25:54 -0400
