=== debian/control ===
Source: libm2k
Section: science
Priority: optional
Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
Uploaders: A. Maitland Bottoms <bottoms@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               dh-python,
               libgoogle-glog-dev,
               libiio-dev,
               python3-dev,
               python3-setuptools,
               swig
Build-Depends-Indep: doxygen,
                     graphviz,
                     python3-sphinx,
                     python3-sphinx-rtd-theme
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://github.com/analogdevicesinc/libm2k
Vcs-Browser: https://salsa.debian.org/debian-hamradio-team/libm2k
Vcs-Git: https://salsa.debian.org/debian-hamradio-team/libm2k.git

Package: libm2k0.9.0
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: ADI library for interfacing with the ADALM2000
 libm2k is a C++ library for interfacing with the ADALM2000.
 These M2K components represent the functionalities of ADALM2000:
 .
  - AnalogIn - oscilloscope or voltmeter
  - AnalogOut - signal generator
  - Digital - logic analyzer or pattern generator
  - PowerSupply - constant voltage generator
  - DMM - digital multimeter
 .
 This package installs the C++ library itself.

Package: libm2k-dev
Architecture: any
Section: libdevel
Depends: libm2k0.9.0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: ADI library headers for interfacing with the ADALM2000
 libm2k is a C++ library for interfacing with the ADALM2000.
 These M2K components represent the functionalities of ADALM2000:
 .
  - AnalogIn - oscilloscope or voltmeter
  - AnalogOut - signal generator
  - Digital - logic analyzer or pattern generator
  - PowerSupply - constant voltage generator
  - DMM - digital multimeter
 .
 This package installs the C++ headers and development files.

Package: libm2k-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: libjs-sphinxdoc, ${misc:Depends}, ${shlibs:Depends}
Description: ADI ADALM2000 documentation
 libm2k is a C++ library for interfacing with the ADALM2000.
 These M2K components represent the functionalities of ADALM2000:
 .
  - AnalogIn - oscilloscope or voltmeter
  - AnalogOut - signal generator
  - Digital - logic analyzer or pattern generator
  - PowerSupply - constant voltage generator
  - DMM - digital multimeter
 .
 This package installs the Doxygen made documentation.

Package: m2kcli
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: ADI tool for interfacing with the ADALM2000
 libm2k is a C++ library for interfacing with the ADALM2000.
 These M2K components represent the functionalities of ADALM2000:
 .
  - AnalogIn - oscilloscope or voltmeter
  - AnalogOut - signal generator
  - Digital - logic analyzer or pattern generator
  - PowerSupply - constant voltage generator
  - DMM - digital multimeter
 .
 This package installs the m2kcli command-line tool.

Package: python3-libm2k
Architecture: any
Section: python
Depends: libm2k0.9.0 (= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Description: Python ADI library for interfacing with the ADALM2000
 Python libm2k library for interfacing with the ADALM2000.
 These M2K components represent the functionalities of ADALM2000:
 .
  - AnalogIn - oscilloscope or voltmeter
  - AnalogOut - signal generator
  - Digital - logic analyzer or pattern generator
  - PowerSupply - constant voltage generator
  - DMM - digital multimeter
 .
 This package installs the Python bindings for the library.
