=== debian/rules ===
#!/usr/bin/make -f
export DEB_HOST_MULTIARCH
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --with python3 --buildsystem=cmake

override_dh_auto_configure-arch:
	dh_auto_configure --buildsystem=cmake -- \
	-DCMAKE_POLICY_VERSION_MINIMUM=3.5 \
	-DCMAKE_SKIP_BUILD_RPATH=ON \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo \
	-DENABLE_PYTHON=ON \
	-DENABLE_LOG=ON \
	-DENABLE_TOOLS=ON

override_dh_auto_configure-indep:
	dh_auto_configure --buildsystem=cmake -- \
	-DCMAKE_POLICY_VERSION_MINIMUM=3.5 \
	-DCMAKE_SKIP_BUILD_RPATH=ON \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo \
	-DENABLE_PYTHON=ON \
	-DENABLE_LOG=ON \
	-DENABLE_TOOLS=ON \
	-DENABLE_DOC=ON

override_dh_auto_build-indep:
	dh_auto_build
	dh_auto_build -- doc
